<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="fr">
<head>
<!-- Generated by javadoc (version 1.7.0_79) on Thu Jun 23 07:55:02 CEST 2016 -->
<title>Game</title>
<meta name="date" content="2016-06-23">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Game";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Game.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../controler/Drop.html" title="class in controler"><span class="strong">Prev Class</span></a></li>
<li><a href="../controler/GameOnline.html" title="class in controler"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?controler/Game.html" target="_top">Frames</a></li>
<li><a href="Game.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">controler</div>
<h2 title="Class Game" class="title">Class Game</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>controler.Game</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../controler/GameOnline.html" title="class in controler">GameOnline</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="strong">Game</span>
extends java.lang.Object</pre>
<div class="block">The Class Game is the main class use for the functionment of the game. This class make the connection beetwen the model and the view.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../controler/Game.html#Game(model.GameRule,%20view.Blokus)">Game</a></strong>(<a href="../model/GameRule.html" title="class in model">GameRule</a>&nbsp;gr,
    <a href="../view/Blokus.html" title="class in view">Blokus</a>&nbsp;blokus)</code>
<div class="block">Instantiates a new game.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#confirmPosition()">confirmPosition</a></strong>()</code>
<div class="block">If the nextPiece and the nextPosition are valid,this method place the piece in the
 map and the grid, and remove it in the player and return true.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../model/Player.html" title="class in model">Player</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getActualPlayer()">getActualPlayer</a></strong>()</code>
<div class="block">Gets the actual player.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../model/GameRule.html" title="class in model">GameRule</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getGameRule()">getGameRule</a></strong>()</code>
<div class="block">Gets the gameRule of this game.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../view/Grid.html" title="class in view">Grid</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getGrid()">getGrid</a></strong>()</code>
<div class="block">Gets the actual grid.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../view/PlayerPiece.html" title="class in view">PlayerPiece</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getLastPiece()">getLastPiece</a></strong>()</code>
<div class="block">Gets the last playerPiece (in view)</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../model/Map.html" title="class in model">Map</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getMap()">getMap</a></strong>()</code>
<div class="block">Gets the map of this games gamerule.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../model/Piece.html" title="class in model">Piece</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getNextPiece()">getNextPiece</a></strong>()</code>
<div class="block">Gets the next piece to place.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../model/Position.html" title="class in model">Position</a></code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getNextPosition()">getNextPosition</a></strong>()</code>
<div class="block">Gets the next position.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../model/Player.html" title="class in model">Player</a>[]</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#getPlayers()">getPlayers</a></strong>()</code>
<div class="block">Gets the players of this game.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#isActualPlayer(model.Player)">isActualPlayer</a></strong>(<a href="../model/Player.html" title="class in model">Player</a>&nbsp;p)</code>
<div class="block">Checks if the player in param is the actual player.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#nextTour()">nextTour</a></strong>()</code>
<div class="block">This method actualize the state of the player, who play, if the game is finish, tell the IA to play.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#removeNextPiece()">removeNextPiece</a></strong>()</code>
<div class="block">Removes the next piece.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#setLastPiece(view.PlayerPiece)">setLastPiece</a></strong>(<a href="../view/PlayerPiece.html" title="class in view">PlayerPiece</a>&nbsp;piece)</code>
<div class="block">Sets the last playerPiece (in view).</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#setNextPiece(model.Piece)">setNextPiece</a></strong>(<a href="../model/Piece.html" title="class in model">Piece</a>&nbsp;nextPiece)</code>
<div class="block">Sets the next piece.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#setNextPosition(model.Position)">setNextPosition</a></strong>(<a href="../model/Position.html" title="class in model">Position</a>&nbsp;nextPosition)</code>
<div class="block">Sets the next position.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../controler/Game.html#synchro()">synchro</a></strong>()</code>
<div class="block">Synchronize this game (in view) with its GameRule.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Game(model.GameRule, view.Blokus)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Game</h4>
<pre>public&nbsp;Game(<a href="../model/GameRule.html" title="class in model">GameRule</a>&nbsp;gr,
    <a href="../view/Blokus.html" title="class in view">Blokus</a>&nbsp;blokus)</pre>
<div class="block">Instantiates a new game.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>gr</code> - the GameRule of this game</dd><dd><code>blokus</code> - the frame who contains and display the game.</dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="synchro()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>synchro</h4>
<pre>public&nbsp;void&nbsp;synchro()</pre>
<div class="block">Synchronize this game (in view) with its GameRule. (used in the only mode and when we restart a game)</div>
</li>
</ul>
<a name="getGrid()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getGrid</h4>
<pre>public&nbsp;<a href="../view/Grid.html" title="class in view">Grid</a>&nbsp;getGrid()</pre>
<div class="block">Gets the actual grid.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the grid</dd></dl>
</li>
</ul>
<a name="getPlayers()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPlayers</h4>
<pre>public&nbsp;<a href="../model/Player.html" title="class in model">Player</a>[]&nbsp;getPlayers()</pre>
<div class="block">Gets the players of this game.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the players</dd></dl>
</li>
</ul>
<a name="getActualPlayer()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getActualPlayer</h4>
<pre>public&nbsp;<a href="../model/Player.html" title="class in model">Player</a>&nbsp;getActualPlayer()</pre>
<div class="block">Gets the actual player.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the actual player</dd></dl>
</li>
</ul>
<a name="getLastPiece()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLastPiece</h4>
<pre>public&nbsp;<a href="../view/PlayerPiece.html" title="class in view">PlayerPiece</a>&nbsp;getLastPiece()</pre>
<div class="block">Gets the last playerPiece (in view)</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the last piece</dd></dl>
</li>
</ul>
<a name="setLastPiece(view.PlayerPiece)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setLastPiece</h4>
<pre>public&nbsp;void&nbsp;setLastPiece(<a href="../view/PlayerPiece.html" title="class in view">PlayerPiece</a>&nbsp;piece)</pre>
<div class="block">Sets the last playerPiece (in view).</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>piece</code> - the new last piece</dd></dl>
</li>
</ul>
<a name="getNextPiece()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNextPiece</h4>
<pre>public&nbsp;<a href="../model/Piece.html" title="class in model">Piece</a>&nbsp;getNextPiece()</pre>
<div class="block">Gets the next piece to place.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the next piece</dd></dl>
</li>
</ul>
<a name="getNextPosition()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNextPosition</h4>
<pre>public&nbsp;<a href="../model/Position.html" title="class in model">Position</a>&nbsp;getNextPosition()</pre>
<div class="block">Gets the next position.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the next position</dd></dl>
</li>
</ul>
<a name="setNextPiece(model.Piece)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setNextPiece</h4>
<pre>public&nbsp;void&nbsp;setNextPiece(<a href="../model/Piece.html" title="class in model">Piece</a>&nbsp;nextPiece)</pre>
<div class="block">Sets the next piece.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>nextPiece</code> - the new next piece</dd></dl>
</li>
</ul>
<a name="setNextPosition(model.Position)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setNextPosition</h4>
<pre>public&nbsp;void&nbsp;setNextPosition(<a href="../model/Position.html" title="class in model">Position</a>&nbsp;nextPosition)</pre>
<div class="block">Sets the next position.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>nextPosition</code> - the new next position</dd></dl>
</li>
</ul>
<a name="nextTour()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nextTour</h4>
<pre>public&nbsp;void&nbsp;nextTour()</pre>
<div class="block">This method actualize the state of the player, who play, if the game is finish, tell the IA to play.
 Its the "engine" of this game.</div>
</li>
</ul>
<a name="removeNextPiece()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeNextPiece</h4>
<pre>public&nbsp;void&nbsp;removeNextPiece()</pre>
<div class="block">Removes the next piece.</div>
</li>
</ul>
<a name="confirmPosition()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>confirmPosition</h4>
<pre>public&nbsp;boolean&nbsp;confirmPosition()</pre>
<div class="block">If the nextPiece and the nextPosition are valid,this method place the piece in the
 map and the grid, and remove it in the player and return true.
 Else it return false.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>true, if successful</dd></dl>
</li>
</ul>
<a name="getMap()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMap</h4>
<pre>public&nbsp;<a href="../model/Map.html" title="class in model">Map</a>&nbsp;getMap()</pre>
<div class="block">Gets the map of this games gamerule.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the map</dd></dl>
</li>
</ul>
<a name="getGameRule()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getGameRule</h4>
<pre>public&nbsp;<a href="../model/GameRule.html" title="class in model">GameRule</a>&nbsp;getGameRule()</pre>
<div class="block">Gets the gameRule of this game.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the game rule</dd></dl>
</li>
</ul>
<a name="isActualPlayer(model.Player)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>isActualPlayer</h4>
<pre>public&nbsp;boolean&nbsp;isActualPlayer(<a href="../model/Player.html" title="class in model">Player</a>&nbsp;p)</pre>
<div class="block">Checks if the player in param is the actual player.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>p</code> - the player to test</dd>
<dt><span class="strong">Returns:</span></dt><dd>true, if p is the actual player</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Game.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../controler/Drop.html" title="class in controler"><span class="strong">Prev Class</span></a></li>
<li><a href="../controler/GameOnline.html" title="class in controler"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?controler/Game.html" target="_top">Frames</a></li>
<li><a href="Game.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
